gtkmm 3.24.10

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::GestureRotate Class Reference
Event Controllers and Gestures

Rotate gesture. More...

`#include <gtkmm/gesturerotate.h>`

Inheritance diagram for Gtk::GestureRotate:
[legend]

## Public Member Functions
| GestureRotate (GestureRotate && src) noexcept
GestureRotate & | operator= (GestureRotate && src) noexcept
| ~GestureRotate () noexcept override
GtkGestureRotate * | gobj ()
| Provides access to the underlying C GObject.
const GtkGestureRotate * | gobj () const
| Provides access to the underlying C GObject.
GtkGestureRotate * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
double | get_angle_delta () const
| If gesture is active, this function returns the angle difference in radians since the gesture was first recognized.
Glib::SignalProxy< void, double, double > | signal_angle_changed ()
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject.
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject.
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the master Gdk::Device that is currently operating on gesture, or nullptr if the gesture is not being interacted.
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the master Gdk::Device that is currently operating on gesture, or nullptr if the gesture is not being interacted.
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with.
EventSequenceState | get_sequence_state (GdkEventSequence * sequence) const
| Returns the sequence state, as seen by gesture.
bool | set_sequence_state (GdkEventSequence * sequence, EventSequenceState state)
| Sets the state of sequence in gesture.
std::vector< const GdkEventSequence * > | get_sequences () const
| Returns the list of GdkEventSequences currently being interpreted.
GdkEventSequence * | get_last_updated_sequence ()
| Returns the Gdk::EventSequence that was last updated on gesture.
const GdkEventSequence * | get_last_updated_sequence () const
| Returns the Gdk::EventSequence that was last updated on gesture.
bool | handles_sequence (GdkEventSequence * sequence) const
| Returns true if gesture is currently handling events corresponding to sequence.
const GdkEvent * | get_last_event (GdkEventSequence * sequence) const
| Returns the last event that was processed for sequence.
bool | get_point (GdkEventSequence * sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, this function returns true and fills in x and y with the last coordinates stored for that event sequence.
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, this function returns true and fills in rect with the bounding box containing all active touches.
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, this function returns true and fills in x and y with the center of the bounding box containing all active touches.
bool | is_active () const
| Returns true if the gesture is currently active.
bool | is_recognized () const
| Returns true if the gesture is currently recognized.
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the user-defined window that receives the events handled by gesture.
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the user-defined window that receives the events handled by gesture.
void | set_window (const Glib::RefPtr< Gdk::Window > & window)
| Sets a specific window to receive events about, so gesture will effectively handle only events targeting window, or a child of it.
void | unset_window ()
| Undoes the effect of previous calls to set_window(), so the gesture will handle events targeting any Gdk::Window that pertains to Gtk::EventController::get_widget().
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture.
void | ungroup ()
| Separates gesture into an isolated group.
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture.
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture.
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns true if both gestures pertain to the same group.
Glib::SignalProxy< void, GdkEventSequence * > | signal_begin ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_end ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_update ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_cancel ()
Glib::SignalProxy< void, GdkEventSequence *, EventSequenceState > | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture,.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Window > > | property_window ()
| If non-nullptr, the gesture will only listen for events that happen on this Gdk::Window, or a child of it.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| If non-nullptr, the gesture will only listen for events that happen on this Gdk::Window, or a child of it.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the Gtk::Widget this controller relates to.
const Widget * | get_widget () const
| Returns the Gtk::Widget this controller relates to.
bool | handle_event (const GdkEvent * event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< GestureRotate > | create (Widget & widget)
| Creates a Gesture that recognizes 2-touch rotation gestures.
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| GestureRotate ()
| There is no create() method that corresponds to this constructor, because this constructor shall only be used by derived classes.
| GestureRotate (Widget & widget)
| Constructs a Gesture that recognizes 2-touch rotation gestures.
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::GestureRotate > | wrap (GtkGestureRotate * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Rotate gesture.

This is a Gesture implementation able to recognize 2-finger rotations. Whenever the angle between both handled sequences changes, signal_angle_changed() is emitted.

Since gtkmm 3.14

## Constructor & Destructor Documentation

## ◆ GestureRotate() [1/3]

Gtk::GestureRotate::GestureRotate | ( | GestureRotate && | src | ) |
| noexcept

## ◆ ~GestureRotate()

Gtk::GestureRotate::~GestureRotate | ( |  | ) |
| override noexcept

## ◆ GestureRotate() [2/3]

Gtk::GestureRotate::GestureRotate | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because this constructor shall only be used by derived classes.

## ◆ GestureRotate() [3/3]

Gtk::GestureRotate::GestureRotate | ( | Widget & | widget | ) |
| explicit protected

Constructs a Gesture that recognizes 2-touch rotation gestures.

## Member Function Documentation

## ◆ create()

Glib::RefPtr< GestureRotate > Gtk::GestureRotate::create | ( | Widget & | widget | ) |
| static

Creates a Gesture that recognizes 2-touch rotation gestures.

Since gtkmm 3.14

Parameters

  widget | Widget the gesture relates to.

Returns
  A RefPtr to a new GestureRotate.

## ◆ get_angle_delta()

double Gtk::GestureRotate::get_angle_delta | ( |  | ) | const

If gesture is active, this function returns the angle difference in radians since the gesture was first recognized.

If gesture is not active, 0 is returned.

Since gtkmm 3.14

Returns
  The angle delta in radians.

## ◆ get_type()

GType Gtk::GestureRotate::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkGestureRotate * Gtk::GestureRotate::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGestureRotate * Gtk::GestureRotate::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGestureRotate * Gtk::GestureRotate::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

GestureRotate & Gtk::GestureRotate::operator= | ( | GestureRotate && | src | ) |
| noexcept

## ◆ signal_angle_changed()

Glib::SignalProxy< void, double, double > Gtk::GestureRotate::signal_angle_changed | ( |  | ) |

Slot Prototype:
  void on_my_angle_changed(double angle, double angle_delta)

Flags: Run First

This signal is emitted when the angle between both tracked points changes.

Since gtkmm 3.14

Parameters

  angle | Current angle in radians.
  angle_delta | Difference with the starting angle, in radians.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::GestureRotate > wrap | ( | GtkGestureRotate * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.